Hex Artifact Content

Artifact 6465223bf61764bc5f4b75fbaf222dccffbcb00b:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 43 6c 65 61 6e 20 76 61  bash..# Clean va
0020: 72 69 61 62 6c 65 73 20 77 68 69 63 68 20 77 69  riables which wi
0030: 6c 6c 20 69 6e 74 65 72 66 65 72 65 20 77 69 74  ll interfere wit
0040: 68 20 74 68 65 20 62 75 69 6c 64 0a 75 6e 73 65  h the build.unse
0050: 74 20 4d 41 4b 45 46 4c 41 47 53 20 44 45 53 54  t MAKEFLAGS DEST
0060: 44 49 52 0a 0a 23 20 44 65 74 65 72 6d 69 6e 65  DIR..# Determine
0070: 20 61 70 70 72 6f 70 72 69 61 74 65 20 6d 6f 64   appropriate mod
0080: 65 0a 6d 6f 64 65 3d 22 62 75 69 6c 64 22 0a 63  e.mode="build".c
0090: 61 73 65 20 22 24 31 22 20 69 6e 0a 09 63 6c 65  ase "$1" in..cle
00a0: 61 6e 7c 64 69 73 74 63 6c 65 61 6e 7c 62 75 69  an|distclean|bui
00b0: 6c 64 7c 72 65 74 72 79 29 0a 09 09 6d 6f 64 65  ld|retry)...mode
00c0: 3d 22 24 31 22 0a 09 09 73 68 69 66 74 0a 09 09  ="$1"...shift...
00d0: 3b 3b 0a 65 73 61 63 0a 0a 23 20 44 65 74 65 72  ;;.esac..# Deter
00e0: 6d 69 6e 65 20 77 68 69 63 68 20 54 63 6c 20 76  mine which Tcl v
00f0: 65 72 73 69 6f 6e 20 74 6f 20 62 75 69 6c 64 0a  ersion to build.
0100: 54 43 4c 56 45 52 53 3d 22 38 2e 36 2e 36 22 0a  TCLVERS="8.6.6".
0110: 69 66 20 65 63 68 6f 20 22 24 31 22 20 7c 20 67  if echo "$1" | g
0120: 72 65 70 20 27 5e 5b 30 2d 39 5d 5b 30 2d 39 5d  rep '^[0-9][0-9]
0130: 2a 5c 2e 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  *\.' >/dev/null 
0140: 7c 7c 20 65 63 68 6f 20 22 24 31 22 20 7c 20 65  || echo "$1" | e
0150: 67 72 65 70 20 27 5e 28 63 76 73 7c 66 6f 73 73  grep '^(cvs|foss
0160: 69 6c 29 5f 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c  il)_' >/dev/null
0170: 3b 20 74 68 65 6e 0a 09 54 43 4c 56 45 52 53 3d  ; then..TCLVERS=
0180: 22 24 31 22 0a 0a 09 73 68 69 66 74 0a 66 69 0a  "$1"...shift.fi.
0190: 65 78 70 6f 72 74 20 54 43 4c 56 45 52 53 0a 0a  export TCLVERS..
01a0: 23 20 41 64 64 20 74 68 65 20 68 65 6c 70 65 72  # Add the helper
01b0: 73 20 64 69 72 65 63 74 6f 72 79 20 74 6f 20 74  s directory to t
01c0: 68 65 20 70 61 74 68 0a 50 41 54 48 3d 22 24 28  he path.PATH="$(
01d0: 63 64 20 22 24 28 64 69 72 6e 61 6d 65 20 22 24  cd "$(dirname "$
01e0: 28 77 68 69 63 68 20 22 24 30 22 29 22 29 22 20  (which "$0")")" 
01f0: 26 26 20 70 77 64 29 22 2f 63 6f 6d 6d 6f 6e 2f  && pwd)"/common/
0200: 68 65 6c 70 65 72 73 3a 22 24 7b 50 41 54 48 7d  helpers:"${PATH}
0210: 22 0a 65 78 70 6f 72 74 20 50 41 54 48 0a 0a 23  ".export PATH..#
0220: 20 56 65 72 69 66 79 20 74 68 61 74 20 22 70 72   Verify that "pr
0230: 65 2e 73 68 22 20 68 61 73 20 62 65 65 6e 20 72  e.sh" has been r
0240: 75 6e 20 69 66 20 74 68 69 73 20 69 73 20 61 20  un if this is a 
0250: 64 65 76 65 6c 6f 70 6d 65 6e 74 20 73 6e 61 70  development snap
0260: 73 68 6f 74 20 6f 66 0a 23 20 4b 69 74 43 72 65  shot of.# KitCre
0270: 61 74 6f 72 0a 69 66 20 5b 20 2d 66 20 27 62 75  ator.if [ -f 'bu
0280: 69 6c 64 2f 70 72 65 2e 73 68 27 20 5d 3b 20 74  ild/pre.sh' ]; t
0290: 68 65 6e 0a 09 69 66 20 21 20 66 69 6e 64 20 27  hen..if ! find '
02a0: 6b 69 74 73 68 2f 62 75 69 6c 64 73 72 63 2f 27  kitsh/buildsrc/'
02b0: 20 2d 6e 61 6d 65 20 63 6f 6e 66 69 67 75 72 65   -name configure
02c0: 20 2d 74 79 70 65 20 66 20 32 3e 2f 64 65 76 2f   -type f 2>/dev/
02d0: 6e 75 6c 6c 20 7c 20 67 72 65 70 20 63 6f 6e 66  null | grep conf
02e0: 69 67 75 72 65 20 3e 2f 64 65 76 2f 6e 75 6c 6c  igure >/dev/null
02f0: 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f 20 22 50  ; then...echo "P
0300: 6c 65 61 73 65 20 72 65 6d 65 6d 62 65 72 20 74  lease remember t
0310: 6f 20 72 75 6e 20 27 62 75 69 6c 64 2f 70 72 65  o run 'build/pre
0320: 2e 73 68 27 20 69 66 20 79 6f 75 20 65 78 70 65  .sh' if you expe
0330: 63 74 20 74 68 69 73 20 62 75 69 6c 64 20 74 6f  ct this build to
0340: 20 77 6f 72 6b 2e 22 20 3e 26 32 0a 09 66 69 0a   work." >&2..fi.
0350: 66 69 0a 0a 23 20 44 65 66 69 6e 65 20 74 68 65  fi..# Define the
0360: 20 6c 69 73 74 20 6f 66 20 61 6c 6c 20 70 61 63   list of all pac
0370: 6b 61 67 65 73 2c 20 66 6f 72 20 63 6c 65 61 6e  kages, for clean
0380: 69 6e 67 20 70 75 72 70 6f 73 65 73 0a 4b 49 54  ing purposes.KIT
0390: 43 52 45 41 54 4f 52 5f 41 4c 4c 50 4b 47 53 3d  CREATOR_ALLPKGS=
03a0: 22 6b 69 74 73 68 20 74 63 6c 20 74 63 6c 76 66  "kitsh tcl tclvf
03b0: 73 20 7a 6c 69 62 20 74 6b 20 69 74 63 6c 20 6d  s zlib tk itcl m
03c0: 6b 34 74 63 6c 20 74 68 72 65 61 64 20 64 62 75  k4tcl thread dbu
03d0: 73 20 74 6c 73 20 74 63 6c 78 20 74 63 63 34 74  s tls tclx tcc4t
03e0: 63 6c 20 74 63 6c 6c 69 62 20 75 64 70 20 79 61  cl tcllib udp ya
03f0: 6a 6c 74 63 6c 22 0a 0a 23 20 41 6c 77 61 79 73  jltcl"..# Always
0400: 20 72 65 62 75 69 6c 64 20 6b 69 74 73 68 0a 72   rebuild kitsh.r
0410: 6d 20 2d 66 20 22 6b 69 74 73 68 2f 2e 73 75 63  m -f "kitsh/.suc
0420: 63 65 73 73 22 0a 66 6f 72 20 70 6b 67 20 69 6e  cess".for pkg in
0430: 20 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 41 4c   ${KITCREATOR_AL
0440: 4c 50 4b 47 53 7d 20 24 7b 4b 49 54 43 52 45 41  LPKGS} ${KITCREA
0450: 54 4f 52 5f 50 4b 47 53 7d 3b 20 64 6f 0a 09 69  TOR_PKGS}; do..i
0460: 66 20 5b 20 22 24 7b 6d 6f 64 65 7d 22 20 21 3d  f [ "${mode}" !=
0470: 20 22 72 65 74 72 79 22 20 2d 6f 20 21 20 2d 66   "retry" -o ! -f
0480: 20 22 24 7b 70 6b 67 7d 2f 2e 73 75 63 63 65 73   "${pkg}/.succes
0490: 73 22 20 5d 3b 20 74 68 65 6e 0a 09 09 72 6d 20  s" ]; then...rm 
04a0: 2d 66 20 22 24 7b 70 6b 67 7d 2f 62 75 69 6c 64  -f "${pkg}/build
04b0: 2e 6c 6f 67 22 20 22 24 7b 70 6b 67 7d 2f 2e 73  .log" "${pkg}/.s
04c0: 75 63 63 65 73 73 22 0a 09 09 72 6d 20 2d 72 66  uccess"...rm -rf
04d0: 20 22 24 7b 70 6b 67 7d 2f 6f 75 74 22 20 22 24   "${pkg}/out" "$
04e0: 7b 70 6b 67 7d 2f 69 6e 73 74 22 20 22 24 7b 70  {pkg}/inst" "${p
04f0: 6b 67 7d 2f 62 75 69 6c 64 22 0a 09 09 72 6d 20  kg}/build"...rm 
0500: 2d 72 66 20 22 24 7b 70 6b 67 7d 22 2f 77 6f 72  -rf "${pkg}"/wor
0510: 6b 64 69 72 2d 2a 0a 0a 09 09 72 6d 20 2d 72 66  kdir-*....rm -rf
0520: 20 22 24 7b 70 6b 67 7d 2f 73 72 63 22 2f 74 6d   "${pkg}/src"/tm
0530: 70 2d 2a 0a 09 66 69 0a 0a 09 69 66 20 5b 20 22  p-*..fi...if [ "
0540: 24 7b 6d 6f 64 65 7d 22 20 3d 20 22 64 69 73 74  ${mode}" = "dist
0550: 63 6c 65 61 6e 22 20 5d 3b 20 74 68 65 6e 0a 09  clean" ]; then..
0560: 09 72 6d 20 2d 72 66 20 22 24 7b 70 6b 67 7d 2f  .rm -rf "${pkg}/
0570: 73 72 63 22 0a 09 66 69 0a 64 6f 6e 65 0a 0a 23  src"..fi.done..#
0580: 20 57 65 27 72 65 20 61 6c 6c 20 64 6f 6e 65 20   We're all done 
0590: 69 66 20 77 65 27 72 65 20 69 6e 20 63 6c 65 61  if we're in clea
05a0: 6e 20 6f 72 20 64 69 73 74 63 6c 65 61 6e 20 6d  n or distclean m
05b0: 6f 64 65 0a 69 66 20 5b 20 22 24 7b 6d 6f 64 65  ode.if [ "${mode
05c0: 7d 22 20 3d 20 22 63 6c 65 61 6e 22 20 2d 6f 20  }" = "clean" -o 
05d0: 22 24 7b 6d 6f 64 65 7d 22 20 3d 20 22 64 69 73  "${mode}" = "dis
05e0: 74 63 6c 65 61 6e 22 20 5d 3b 20 74 68 65 6e 0a  tclean" ]; then.
05f0: 09 72 6d 20 2d 66 20 74 63 6c 6b 69 74 2d 2a 0a  .rm -f tclkit-*.
0600: 09 72 6d 20 2d 66 20 6c 69 62 74 63 6c 6b 69 74  .rm -f libtclkit
0610: 2a 2e 2a 0a 0a 09 65 78 69 74 20 30 0a 66 69 0a  *.*...exit 0.fi.
0620: 0a 23 20 41 64 64 20 70 61 63 6b 61 67 65 73 20  .# Add packages 
0630: 69 6d 70 6c 69 65 64 20 62 79 20 74 68 65 20 61  implied by the a
0640: 64 64 69 74 69 6f 6e 61 6c 20 61 72 67 75 6d 65  dditional argume
0650: 6e 74 73 0a 69 66 20 5b 20 2d 7a 20 22 24 7b 4b  nts.if [ -z "${K
0660: 49 54 43 52 45 41 54 4f 52 5f 50 4b 47 53 7d 22  ITCREATOR_PKGS}"
0670: 20 5d 3b 20 74 68 65 6e 0a 09 4b 49 54 43 52 45   ]; then..KITCRE
0680: 41 54 4f 52 5f 50 4b 47 53 3d 22 74 6b 20 69 74  ATOR_PKGS="tk it
0690: 63 6c 20 6d 6b 34 74 63 6c 22 0a 66 69 0a 0a 43  cl mk4tcl".fi..C
06a0: 4f 4e 46 49 47 55 52 45 45 58 54 52 41 3d 22 24  ONFIGUREEXTRA="$
06b0: 40 22 0a 65 78 70 6f 72 74 20 43 4f 4e 46 49 47  @".export CONFIG
06c0: 55 52 45 45 58 54 52 41 0a 0a 69 66 20 65 63 68  UREEXTRA..if ech
06d0: 6f 20 22 20 24 7b 43 4f 4e 46 49 47 55 52 45 45  o " ${CONFIGUREE
06e0: 58 54 52 41 7d 20 22 20 7c 20 67 72 65 70 20 27  XTRA} " | grep '
06f0: 20 2d 2d 65 6e 61 62 6c 65 2d 74 68 72 65 61 64   --enable-thread
0700: 73 20 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32  s ' >/dev/null 2
0710: 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e  >/dev/null; then
0720: 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f 41 44 44  ..KITCREATOR_ADD
0730: 5f 45 4e 41 42 4c 45 5f 54 48 52 45 41 44 53 3d  _ENABLE_THREADS=
0740: 27 31 27 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f  '1'..KITCREATOR_
0750: 50 4b 47 53 3d 22 24 7b 4b 49 54 43 52 45 41 54  PKGS="${KITCREAT
0760: 4f 52 5f 50 4b 47 53 7d 20 74 68 72 65 61 64 22  OR_PKGS} thread"
0770: 0a 65 6c 69 66 20 65 63 68 6f 20 22 20 24 7b 43  .elif echo " ${C
0780: 4f 4e 46 49 47 55 52 45 45 58 54 52 41 7d 20 22  ONFIGUREEXTRA} "
0790: 20 7c 20 67 72 65 70 20 27 20 2d 2d 64 69 73 61   | grep ' --disa
07a0: 62 6c 65 2d 74 68 72 65 61 64 73 20 27 20 3e 2f  ble-threads ' >/
07b0: 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f  dev/null 2>/dev/
07c0: 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 4b 49 54 43  null; then..KITC
07d0: 52 45 41 54 4f 52 5f 41 44 44 5f 45 4e 41 42 4c  REATOR_ADD_ENABL
07e0: 45 5f 54 48 52 45 41 44 53 3d 27 30 27 0a 66 69  E_THREADS='0'.fi
07f0: 0a 0a 23 20 44 65 74 65 72 6d 69 6e 65 20 63 72  ..# Determine cr
0800: 6f 73 73 2d 63 6f 6d 70 69 6c 65 20 73 74 61 74  oss-compile stat
0810: 75 73 0a 68 6f 73 74 5f 6f 73 3d 22 24 28 65 63  us.host_os="$(ec
0820: 68 6f 20 22 20 24 7b 43 4f 4e 46 49 47 55 52 45  ho " ${CONFIGURE
0830: 45 58 54 52 41 7d 20 22 20 7c 20 73 65 64 20 27  EXTRA} " | sed '
0840: 73 40 5e 2e 2a 20 2d 2d 68 6f 73 74 3d 5c 28 5b  s@^.* --host=\([
0850: 5e 20 5d 2a 5c 29 20 2e 2a 24 40 5c 31 40 0a 74  ^ ]*\) .*$@\1@.t
0860: 20 78 0a 64 0a 3a 78 27 29 22 0a 62 75 69 6c 64   x.d.:x')".build
0870: 5f 6f 73 3d 22 24 28 65 63 68 6f 20 22 20 24 7b  _os="$(echo " ${
0880: 43 4f 4e 46 49 47 55 52 45 45 58 54 52 41 7d 20  CONFIGUREEXTRA} 
0890: 22 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 20 2d  " | sed 's@^.* -
08a0: 2d 62 75 69 6c 64 3d 5c 28 5b 5e 20 5d 2a 5c 29  -build=\([^ ]*\)
08b0: 20 2e 2a 24 40 5c 31 40 0a 74 20 78 0a 64 0a 3a   .*$@\1@.t x.d.:
08c0: 78 27 29 22 0a 0a 69 66 20 5b 20 22 24 7b 68 6f  x')"..if [ "${ho
08d0: 73 74 5f 6f 73 7d 22 20 21 3d 20 22 24 7b 62 75  st_os}" != "${bu
08e0: 69 6c 64 5f 6f 73 7d 22 20 2d 61 20 2d 6e 20 22  ild_os}" -a -n "
08f0: 24 7b 68 6f 73 74 5f 6f 73 7d 22 20 5d 3b 20 74  ${host_os}" ]; t
0900: 68 65 6e 0a 09 4b 43 5f 43 52 4f 53 53 43 4f 4d  hen..KC_CROSSCOM
0910: 50 49 4c 45 3d 27 31 27 0a 09 4b 43 5f 43 52 4f  PILE='1'..KC_CRO
0920: 53 53 43 4f 4d 50 49 4c 45 5f 48 4f 53 54 5f 4f  SSCOMPILE_HOST_O
0930: 53 3d 22 24 7b 68 6f 73 74 5f 6f 73 7d 22 0a 65  S="${host_os}".e
0940: 6c 73 65 0a 09 4b 43 5f 43 52 4f 53 53 43 4f 4d  lse..KC_CROSSCOM
0950: 50 49 4c 45 3d 27 30 27 0a 09 4b 43 5f 43 52 4f  PILE='0'..KC_CRO
0960: 53 53 43 4f 4d 50 49 4c 45 5f 48 4f 53 54 5f 4f  SSCOMPILE_HOST_O
0970: 53 3d 27 27 0a 66 69 0a 65 78 70 6f 72 74 20 4b  S=''.fi.export K
0980: 43 5f 43 52 4f 53 53 43 4f 4d 50 49 4c 45 20 4b  C_CROSSCOMPILE K
0990: 43 5f 43 52 4f 53 53 43 4f 4d 50 49 4c 45 5f 48  C_CROSSCOMPILE_H
09a0: 4f 53 54 5f 4f 53 0a 0a 23 20 53 65 74 20 64 65  OST_OS..# Set de
09b0: 66 61 75 6c 74 20 74 61 72 67 65 74 0a 4b 49 54  fault target.KIT
09c0: 54 41 52 47 45 54 3d 22 6b 69 74 73 68 22 0a 65  TARGET="kitsh".e
09d0: 78 70 6f 72 74 20 4b 49 54 54 41 52 47 45 54 0a  xport KITTARGET.
09e0: 0a 23 20 46 69 78 20 75 70 20 70 61 63 6b 61 67  .# Fix up packag
09f0: 65 20 6c 69 73 74 0a 23 23 20 49 66 20 62 75 69  e list.## If bui
0a00: 6c 64 69 6e 67 20 4b 69 74 44 4c 4c 2c 20 64 65  lding KitDLL, de
0a10: 66 69 6e 65 20 69 74 20 61 73 20 6f 75 72 20 74  fine it as our t
0a20: 61 72 67 65 74 0a 69 66 20 65 63 68 6f 20 22 20  arget.if echo " 
0a30: 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47  ${KITCREATOR_PKG
0a40: 53 7d 20 22 20 7c 20 67 72 65 70 20 27 20 6b 69  S} " | grep ' ki
0a50: 74 64 6c 6c 20 27 20 3e 2f 64 65 76 2f 6e 75 6c  tdll ' >/dev/nul
0a60: 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74  l 2>/dev/null; t
0a70: 68 65 6e 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f  hen..KITCREATOR_
0a80: 50 4b 47 53 3d 22 24 28 65 63 68 6f 20 22 20 24  PKGS="$(echo " $
0a90: 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47 53  {KITCREATOR_PKGS
0aa0: 7d 20 22 20 7c 20 73 65 64 20 27 73 40 20 6b 69  } " | sed 's@ ki
0ab0: 74 64 6c 6c 20 40 20 40 67 3b 73 40 5e 20 20 2a  tdll @ @g;s@^  *
0ac0: 40 40 3b 73 40 20 20 2a 24 40 40 3b 73 40 20 20  @@;s@  *$@@;s@  
0ad0: 20 2a 40 20 40 67 27 29 22 0a 09 4b 49 54 54 41   *@ @g')"..KITTA
0ae0: 52 47 45 54 3d 22 6b 69 74 64 6c 6c 22 0a 66 69  RGET="kitdll".fi
0af0: 0a 0a 23 20 49 66 20 74 68 65 20 75 73 65 72 20  ..# If the user 
0b00: 6d 61 6e 75 61 6c 6c 79 20 72 65 71 75 65 73 74  manually request
0b10: 65 64 20 22 2d 2d 65 6e 61 62 6c 65 2d 6b 69 74  ed "--enable-kit
0b20: 64 6c 6c 22 2c 20 6d 61 6b 65 20 69 74 20 73 6f  dll", make it so
0b30: 0a 69 66 20 65 63 68 6f 20 22 78 20 24 40 20 22  .if echo "x $@ "
0b40: 20 7c 20 67 72 65 70 20 27 20 5b 2d 5d 5b 2d 5d   | grep ' [-][-]
0b50: 65 6e 61 62 6c 65 2d 6b 69 74 64 6c 6c 20 27 20  enable-kitdll ' 
0b60: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65  >/dev/null 2>/de
0b70: 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 4b 49  v/null; then..KI
0b80: 54 54 41 52 47 45 54 3d 22 6b 69 74 64 6c 6c 22  TTARGET="kitdll"
0b90: 0a 66 69 0a 0a 23 23 20 49 66 20 62 75 69 6c 64  .fi..## If build
0ba0: 69 6e 67 20 4b 69 74 44 4c 4c 20 61 6e 64 20 54  ing KitDLL and T
0bb0: 6b 2c 20 6d 75 73 74 20 64 6f 20 54 6b 20 73 74  k, must do Tk st
0bc0: 61 74 69 63 61 6c 6c 79 0a 23 23 23 20 28 57 65  atically.### (We
0bd0: 6c 6c 2c 20 77 65 20 64 6f 6e 27 74 20 48 41 56  ll, we don't HAV
0be0: 45 20 74 6f 2c 20 62 75 74 20 69 74 20 77 6f 75  E to, but it wou
0bf0: 6c 64 20 64 65 66 65 61 74 20 6d 75 63 68 20 6f  ld defeat much o
0c00: 66 20 74 68 65 20 70 75 72 70 6f 73 65 29 0a 69  f the purpose).i
0c10: 66 20 5b 20 22 24 7b 4b 49 54 54 41 52 47 45 54  f [ "${KITTARGET
0c20: 7d 22 20 3d 20 22 6b 69 74 64 6c 6c 22 20 5d 3b  }" = "kitdll" ];
0c30: 20 74 68 65 6e 0a 09 69 66 20 65 63 68 6f 20 22   then..if echo "
0c40: 20 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b   ${KITCREATOR_PK
0c50: 47 53 7d 20 22 20 7c 20 67 72 65 70 20 27 20 74  GS} " | grep ' t
0c60: 6b 20 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32  k ' >/dev/null 2
0c70: 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e  >/dev/null; then
0c80: 0a 09 09 69 66 20 5b 20 22 24 7b 53 54 41 54 49  ...if [ "${STATI
0c90: 43 54 4b 7d 22 20 21 3d 20 22 31 22 20 2d 61 20  CTK}" != "1" -a 
0ca0: 22 24 7b 53 54 41 54 49 43 54 4b 7d 22 20 21 3d  "${STATICTK}" !=
0cb0: 20 22 2d 31 22 20 5d 3b 20 74 68 65 6e 0a 09 09   "-1" ]; then...
0cc0: 09 65 63 68 6f 20 27 57 61 72 6e 69 6e 67 3a 20  .echo 'Warning: 
0cd0: 4c 69 6e 6b 69 6e 67 20 54 6b 20 73 74 61 74 69  Linking Tk stati
0ce0: 63 61 6c 6c 79 20 62 65 63 61 75 73 65 20 79 6f  cally because yo
0cf0: 75 20 61 72 65 20 62 75 69 6c 64 69 6e 67 20 4b  u are building K
0d00: 69 74 44 4c 4c 27 20 32 3e 26 31 0a 09 09 09 65  itDLL' 2>&1....e
0d10: 63 68 6f 20 27 20 20 20 20 20 20 20 20 20 53 65  cho '         Se
0d20: 74 20 53 54 41 54 49 43 54 4b 20 74 6f 20 2d 31  t STATICTK to -1
0d30: 20 69 66 20 79 6f 75 20 72 65 61 6c 6c 79 20 77   if you really w
0d40: 61 6e 74 20 74 6f 20 6c 69 6e 6b 20 54 6b 20 64  ant to link Tk d
0d50: 79 6e 61 6d 69 63 61 6c 6c 79 2e 27 20 3e 26 32  ynamically.' >&2
0d60: 0a 0a 09 09 09 53 54 41 54 49 43 54 4b 3d 22 31  .....STATICTK="1
0d70: 22 0a 09 09 09 65 78 70 6f 72 74 20 53 54 41 54  "....export STAT
0d80: 49 43 54 4b 0a 09 09 66 69 0a 09 66 69 0a 0a 09  ICTK...fi..fi...
0d90: 69 66 20 65 63 68 6f 20 22 20 24 7b 4b 49 54 43  if echo " ${KITC
0da0: 52 45 41 54 4f 52 5f 50 4b 47 53 7d 20 22 20 7c  REATOR_PKGS} " |
0db0: 20 67 72 65 70 20 27 20 6d 6b 34 74 63 6c 20 27   grep ' mk4tcl '
0dc0: 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64   >/dev/null 2>/d
0dd0: 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 09  ev/null; then...
0de0: 69 66 20 5b 20 2d 7a 20 22 24 7b 53 54 41 54 49  if [ -z "${STATI
0df0: 43 4d 4b 34 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  CMK4}" ]; then..
0e00: 09 09 65 63 68 6f 20 27 57 61 72 6e 69 6e 67 3a  ..echo 'Warning:
0e10: 20 4c 69 6e 6b 69 6e 67 20 4d 6b 34 74 63 6c 20   Linking Mk4tcl 
0e20: 64 79 6e 61 6d 69 63 61 6c 6c 79 20 62 65 63 61  dynamically beca
0e30: 75 73 65 20 79 6f 75 20 61 72 65 20 62 75 69 6c  use you are buil
0e40: 64 69 6e 67 20 4b 69 74 44 4c 4c 27 20 32 3e 26  ding KitDLL' 2>&
0e50: 31 0a 09 09 09 65 63 68 6f 20 27 20 20 20 20 20  1....echo '     
0e60: 20 20 20 20 53 65 74 20 53 54 41 54 49 43 4d 4b      Set STATICMK
0e70: 34 20 74 6f 20 6d 61 6b 65 20 74 68 69 73 20 6d  4 to make this m
0e80: 65 73 73 61 67 65 20 67 6f 20 61 77 61 79 2e 27  essage go away.'
0e90: 20 3e 26 32 0a 09 09 09 65 63 68 6f 20 27 20 20   >&2....echo '  
0ea0: 20 20 20 20 20 20 20 53 65 74 20 53 54 41 54 49         Set STATI
0eb0: 43 4d 4b 34 20 74 6f 20 31 20 69 66 20 79 6f 75  CMK4 to 1 if you
0ec0: 20 72 65 61 6c 6c 79 20 77 61 6e 74 20 74 6f 20   really want to 
0ed0: 6c 69 6e 6b 20 4d 6b 34 74 63 6c 20 73 74 61 74  link Mk4tcl stat
0ee0: 69 63 61 6c 6c 79 20 28 6e 6f 72 6d 61 6c 20 64  ically (normal d
0ef0: 65 66 61 75 6c 74 29 2e 27 20 3e 26 32 0a 09 09  efault).' >&2...
0f00: 09 65 63 68 6f 20 27 20 20 20 20 20 20 20 20 20  .echo '         
0f10: 53 65 74 20 53 54 41 54 49 43 4d 4b 34 20 74 6f  Set STATICMK4 to
0f20: 20 30 20 74 6f 20 6c 69 6e 6b 20 4d 6b 34 74 63   0 to link Mk4tc
0f30: 6c 20 64 79 6e 61 6d 69 63 61 6c 6c 79 20 69 66  l dynamically if
0f40: 20 70 6f 73 73 69 62 6c 65 20 28 74 68 69 73 20   possible (this 
0f50: 69 73 20 77 68 61 74 20 69 73 20 68 61 70 70 65  is what is happe
0f60: 6e 69 6e 67 20 6e 6f 77 29 2e 27 20 3e 26 32 0a  ning now).' >&2.
0f70: 09 09 09 65 63 68 6f 20 27 20 20 20 20 20 20 20  ...echo '       
0f80: 20 20 53 65 74 20 53 54 41 54 49 43 4d 4b 34 20    Set STATICMK4 
0f90: 74 6f 20 2d 31 20 74 6f 20 62 75 69 6c 64 20 64  to -1 to build d
0fa0: 79 6e 61 6d 69 63 61 6c 6c 79 2e 27 20 3e 26 32  ynamically.' >&2
0fb0: 0a 0a 09 09 09 53 54 41 54 49 43 4d 4b 34 3d 22  .....STATICMK4="
0fc0: 30 22 0a 09 09 09 65 78 70 6f 72 74 20 53 54 41  0"....export STA
0fd0: 54 49 43 4d 4b 34 0a 09 09 66 69 0a 09 66 69 0a  TICMK4...fi..fi.
0fe0: 66 69 0a 0a 23 20 46 69 6e 64 20 57 69 6e 64 6f  fi..# Find Windo
0ff0: 77 73 20 72 65 73 6f 75 72 63 65 2d 72 65 6c 61  ws resource-rela
1000: 74 65 64 20 66 69 6c 65 73 0a 69 66 20 5b 20 2d  ted files.if [ -
1010: 66 20 22 6b 69 74 2e 69 63 6f 22 20 5d 3b 20 74  f "kit.ico" ]; t
1020: 68 65 6e 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f  hen..KITCREATOR_
1030: 49 43 4f 4e 3d 22 24 28 70 77 64 29 2f 6b 69 74  ICON="$(pwd)/kit
1040: 2e 69 63 6f 22 0a 65 6c 73 65 0a 09 4b 49 54 43  .ico".else..KITC
1050: 52 45 41 54 4f 52 5f 49 43 4f 4e 3d 22 24 28 65  REATOR_ICON="$(e
1060: 63 68 6f 20 22 24 28 70 77 64 29 2f 6b 69 74 73  cho "$(pwd)/kits
1070: 68 2f 62 75 69 6c 64 73 72 63 22 2f 6b 69 74 73  h/buildsrc"/kits
1080: 68 2d 2a 2f 74 63 6c 6b 69 74 2e 69 63 6f 29 22  h-*/tclkit.ico)"
1090: 0a 66 69 0a 69 66 20 5b 20 2d 66 20 22 6b 69 74  .fi.if [ -f "kit
10a0: 2e 72 63 22 20 5d 3b 20 74 68 65 6e 0a 09 4b 49  .rc" ]; then..KI
10b0: 54 43 52 45 41 54 4f 52 5f 52 43 3d 22 24 28 70  TCREATOR_RC="$(p
10c0: 77 64 29 2f 6b 69 74 2e 72 63 22 0a 65 6c 73 65  wd)/kit.rc".else
10d0: 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f 52 43 3d  ..KITCREATOR_RC=
10e0: 22 24 28 65 63 68 6f 20 22 24 28 70 77 64 29 2f  "$(echo "$(pwd)/
10f0: 6b 69 74 73 68 2f 62 75 69 6c 64 73 72 63 22 2f  kitsh/buildsrc"/
1100: 6b 69 74 73 68 2d 2a 2f 6b 69 74 2e 72 63 29 22  kitsh-*/kit.rc)"
1110: 0a 66 69 0a 65 78 70 6f 72 74 20 4b 49 54 43 52  .fi.export KITCR
1120: 45 41 54 4f 52 5f 49 43 4f 4e 20 4b 49 54 43 52  EATOR_ICON KITCR
1130: 45 41 54 4f 52 5f 52 43 0a 0a 23 20 44 65 74 65  EATOR_RC..# Dete
1140: 72 6d 69 6e 65 20 68 6f 77 20 77 65 20 69 6e 76  rmine how we inv
1150: 6f 6b 65 20 61 20 54 63 6c 20 69 6e 74 65 72 70  oke a Tcl interp
1160: 72 65 74 65 72 0a 69 66 20 5b 20 2d 7a 20 22 24  reter.if [ -z "$
1170: 7b 54 43 4c 53 48 5f 4e 41 54 49 56 45 7d 22 20  {TCLSH_NATIVE}" 
1180: 5d 3b 20 74 68 65 6e 0a 09 54 43 4c 53 48 5f 4e  ]; then..TCLSH_N
1190: 41 54 49 56 45 3d 22 66 61 6c 73 65 22 0a 66 69  ATIVE="false".fi
11a0: 0a 66 6f 72 20 74 65 73 74 73 68 20 69 6e 20 22  .for testsh in "
11b0: 24 7b 54 43 4c 53 48 5f 4e 41 54 49 56 45 7d 22  ${TCLSH_NATIVE}"
11c0: 20 74 63 6c 73 68 20 74 63 6c 73 68 38 2e 34 20   tclsh tclsh8.4 
11d0: 74 63 6c 73 68 38 2e 35 20 74 63 6c 73 68 38 2e  tclsh8.5 tclsh8.
11e0: 36 20 22 24 7b 54 43 4c 4b 49 54 3a 2d 74 63 6c  6 "${TCLKIT:-tcl
11f0: 6b 69 74 7d 22 3b 20 64 6f 0a 09 69 66 20 65 63  kit}"; do..if ec
1200: 68 6f 20 27 65 78 69 74 20 30 27 20 7c 20 22 24  ho 'exit 0' | "$
1210: 7b 74 65 73 74 73 68 7d 22 20 3e 2f 64 65 76 2f  {testsh}" >/dev/
1220: 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c  null 2>/dev/null
1230: 3b 20 74 68 65 6e 0a 09 09 54 43 4c 53 48 5f 4e  ; then...TCLSH_N
1240: 41 54 49 56 45 3d 22 24 7b 74 65 73 74 73 68 7d  ATIVE="${testsh}
1250: 22 0a 0a 09 09 62 72 65 61 6b 0a 09 66 69 0a 64  "....break..fi.d
1260: 6f 6e 65 0a 65 78 70 6f 72 74 20 54 43 4c 53 48  one.export TCLSH
1270: 5f 4e 41 54 49 56 45 0a 0a 23 20 46 75 6e 63 74  _NATIVE..# Funct
1280: 69 6f 6e 20 74 6f 20 64 65 74 65 72 6d 69 6e 65  ion to determine
1290: 20 77 68 61 74 20 62 75 69 6c 64 20 6d 6f 64 65   what build mode
12a0: 20 69 73 20 62 65 69 6e 67 20 75 73 65 64 0a 66   is being used.f
12b0: 75 6e 63 74 69 6f 6e 20 75 73 65 43 6f 6d 6d 6f  unction useCommo
12c0: 6e 42 75 69 6c 64 53 79 73 74 65 6d 28 29 20 7b  nBuildSystem() {
12d0: 0a 09 6c 6f 63 61 6c 20 73 63 72 69 70 74 0a 0a  ..local script..
12e0: 09 73 63 72 69 70 74 3d 22 24 31 22 0a 0a 09 69  .script="$1"...i
12f0: 66 20 67 72 65 70 20 2d 69 20 27 5e 23 20 2a 42  f grep -i '^# *B
1300: 75 69 6c 64 43 6f 6d 70 61 74 69 62 6c 65 3a 20  uildCompatible: 
1310: 2a 4b 69 74 43 72 65 61 74 6f 72 20 2a 24 27 20  *KitCreator *$' 
1320: 22 24 7b 73 63 72 69 70 74 7d 22 20 3e 2f 64 65  "${script}" >/de
1330: 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75  v/null 2>/dev/nu
1340: 6c 6c 3b 20 74 68 65 6e 0a 09 09 72 65 74 75 72  ll; then...retur
1350: 6e 20 30 0a 09 66 69 0a 0a 09 72 65 74 75 72 6e  n 0..fi...return
1360: 20 31 0a 7d 0a 0a 23 20 43 6c 65 61 6e 75 70 20   1.}..# Cleanup 
1370: 62 75 69 6c 64 20 6c 6f 67 73 0a 66 6f 72 20 70  build logs.for p
1380: 6b 67 20 69 6e 20 74 63 6c 20 74 63 6c 76 66 73  kg in tcl tclvfs
1390: 20 7a 6c 69 62 20 24 7b 4b 49 54 43 52 45 41 54   zlib ${KITCREAT
13a0: 4f 52 5f 50 4b 47 53 7d 20 6b 69 74 73 68 3b 20  OR_PKGS} kitsh; 
13b0: 64 6f 0a 09 72 6d 20 2d 66 20 22 24 7b 70 6b 67  do..rm -f "${pkg
13c0: 7d 2f 62 75 69 6c 64 2e 6c 6f 67 22 0a 64 6f 6e  }/build.log".don
13d0: 65 0a 0a 23 20 56 65 72 69 66 79 20 74 68 61 74  e..# Verify that
13e0: 20 65 61 63 68 20 63 6f 6d 70 6f 6e 65 6e 74 20   each component 
13f0: 69 73 20 68 61 70 70 79 20 77 69 74 68 20 74 68  is happy with th
1400: 65 20 65 6e 76 69 72 6f 6e 6d 65 6e 74 0a 76 61  e environment.va
1410: 6c 69 64 61 74 65 66 61 69 6c 65 64 3d 22 30 22  lidatefailed="0"
1420: 0a 66 6f 72 20 70 6b 67 20 69 6e 20 74 63 6c 20  .for pkg in tcl 
1430: 74 63 6c 76 66 73 20 7a 6c 69 62 20 24 7b 4b 49  tclvfs zlib ${KI
1440: 54 43 52 45 41 54 4f 52 5f 50 4b 47 53 7d 20 6b  TCREATOR_PKGS} k
1450: 69 74 73 68 3b 20 64 6f 0a 09 66 61 69 6c 65 64  itsh; do..failed
1460: 3d 27 30 27 0a 09 69 66 20 5b 20 2d 66 20 22 24  ='0'..if [ -f "$
1470: 7b 70 6b 67 7d 2f 2e 73 75 63 63 65 73 73 22 20  {pkg}/.success" 
1480: 5d 3b 20 74 68 65 6e 0a 09 09 63 6f 6e 74 69 6e  ]; then...contin
1490: 75 65 0a 09 66 69 0a 0a 09 69 66 20 5b 20 2d 78  ue..fi...if [ -x
14a0: 20 22 24 7b 70 6b 67 7d 2f 76 61 6c 69 64 61 74   "${pkg}/validat
14b0: 65 2e 73 68 22 20 5d 3b 20 74 68 65 6e 0a 09 09  e.sh" ]; then...
14c0: 28 0a 09 09 09 63 64 20 22 24 7b 70 6b 67 7d 22  (....cd "${pkg}"
14d0: 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64   >/dev/null 2>/d
14e0: 65 76 2f 6e 75 6c 6c 20 7c 7c 20 65 78 69 74 20  ev/null || exit 
14f0: 31 0a 0a 09 09 09 2e 2f 76 61 6c 69 64 61 74 65  1....../validate
1500: 2e 73 68 20 33 3e 26 31 20 34 3e 26 32 20 3e 3e  .sh 3>&1 4>&2 >>
1510: 20 62 75 69 6c 64 2e 6c 6f 67 20 32 3e 26 31 20   build.log 2>&1 
1520: 7c 7c 20 65 78 69 74 20 31 0a 09 09 29 20 7c 7c  || exit 1...) ||
1530: 20 66 61 69 6c 65 64 3d 22 31 22 0a 0a 09 09 69   failed="1"....i
1540: 66 20 5b 20 22 24 7b 66 61 69 6c 65 64 7d 22 20  f [ "${failed}" 
1550: 3d 20 27 31 27 20 5d 3b 20 74 68 65 6e 0a 09 09  = '1' ]; then...
1560: 09 65 63 68 6f 20 22 46 61 69 6c 65 64 20 70 72  .echo "Failed pr
1570: 65 2d 72 65 71 75 69 73 69 74 65 20 63 68 65 63  e-requisite chec
1580: 6b 20 66 6f 72 20 24 7b 70 6b 67 7d 22 20 3e 26  k for ${pkg}" >&
1590: 32 0a 0a 09 09 09 76 61 6c 69 64 61 74 65 66 61  2.....validatefa
15a0: 69 6c 65 64 3d 27 31 27 0a 09 09 66 69 0a 09 66  iled='1'...fi..f
15b0: 69 0a 64 6f 6e 65 0a 0a 69 66 20 5b 20 22 24 7b  i.done..if [ "${
15c0: 76 61 6c 69 64 61 74 65 66 61 69 6c 65 64 7d 22  validatefailed}"
15d0: 20 3d 20 27 31 27 20 5d 3b 20 74 68 65 6e 0a 09   = '1' ]; then..
15e0: 65 78 69 74 20 31 0a 66 69 0a 0a 23 20 44 6f 20  exit 1.fi..# Do 
15f0: 62 75 69 6c 64 0a 66 61 69 6c 65 64 70 6b 67 73  build.failedpkgs
1600: 3d 22 22 0a 62 75 69 6c 64 66 61 69 6c 65 64 3d  ="".buildfailed=
1610: 22 30 22 0a 66 6f 72 20 70 6b 67 20 69 6e 20 74  "0".for pkg in t
1620: 63 6c 20 74 63 6c 76 66 73 20 7a 6c 69 62 20 24  cl tclvfs zlib $
1630: 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47 53  {KITCREATOR_PKGS
1640: 7d 20 6b 69 74 73 68 3b 20 64 6f 0a 09 66 61 69  } kitsh; do..fai
1650: 6c 65 64 3d 22 30 22 0a 09 69 66 20 5b 20 2d 66  led="0"..if [ -f
1660: 20 22 24 7b 70 6b 67 7d 2f 2e 73 75 63 63 65 73   "${pkg}/.succes
1670: 73 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63 68  s" ]; then...ech
1680: 6f 20 2d 6e 20 22 53 6b 69 70 70 69 6e 67 20 24  o -n "Skipping $
1690: 7b 70 6b 67 7d 20 2e 2e 2e 22 0a 09 65 6c 73 65  {pkg} ..."..else
16a0: 0a 09 09 65 63 68 6f 20 2d 6e 20 22 42 75 69 6c  ...echo -n "Buil
16b0: 64 69 6e 67 20 24 7b 70 6b 67 7d 20 2e 2e 2e 22  ding ${pkg} ..."
16c0: 0a 0a 09 09 28 0a 09 09 09 63 64 20 22 24 7b 70  ....(....cd "${p
16d0: 6b 67 7d 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  kg}" >/dev/null 
16e0: 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c 7c 20 65  2>/dev/null || e
16f0: 78 69 74 20 31 0a 0a 09 09 09 62 75 69 6c 64 5f  xit 1.....build_
1700: 73 63 72 69 70 74 3d 27 2e 2f 62 75 69 6c 64 2e  script='./build.
1710: 73 68 27 0a 09 09 09 69 66 20 5b 20 2d 78 20 27  sh'....if [ -x '
1720: 6b 69 74 63 72 65 61 74 6f 72 2d 62 75 69 6c 64  kitcreator-build
1730: 2e 73 68 27 20 5d 3b 20 74 68 65 6e 0a 09 09 09  .sh' ]; then....
1740: 09 62 75 69 6c 64 5f 73 63 72 69 70 74 3d 27 2e  .build_script='.
1750: 2f 6b 69 74 63 72 65 61 74 6f 72 2d 62 75 69 6c  /kitcreator-buil
1760: 64 2e 73 68 27 0a 09 09 09 66 69 0a 0a 09 09 09  d.sh'....fi.....
1770: 69 66 20 5b 20 2d 66 20 22 24 7b 62 75 69 6c 64  if [ -f "${build
1780: 5f 73 63 72 69 70 74 7d 22 20 5d 3b 20 74 68 65  _script}" ]; the
1790: 6e 0a 09 09 09 09 62 75 69 6c 64 5f 73 63 72 69  n.....build_scri
17a0: 70 74 73 3d 28 22 24 7b 62 75 69 6c 64 5f 73 63  pts=("${build_sc
17b0: 72 69 70 74 7d 22 29 0a 09 09 09 65 6c 73 65 0a  ript}")....else.
17c0: 09 09 09 09 62 75 69 6c 64 5f 73 63 72 69 70 74  ....build_script
17d0: 73 3d 28 24 28 65 63 68 6f 20 62 75 69 6c 64 2d  s=($(echo build-
17e0: 6b 69 74 63 72 65 61 74 6f 72 2d 2a 2e 73 68 29  kitcreator-*.sh)
17f0: 29 0a 09 09 09 66 69 0a 0a 09 09 09 63 61 6c 6c  )....fi.....call
1800: 5f 70 6b 67 5f 69 6e 69 74 3d 27 31 27 0a 09 09  _pkg_init='1'...
1810: 09 66 6f 72 20 62 75 69 6c 64 5f 73 63 72 69 70  .for build_scrip
1820: 74 20 69 6e 20 22 24 7b 62 75 69 6c 64 5f 73 63  t in "${build_sc
1830: 72 69 70 74 73 5b 40 5d 7d 22 3b 20 64 6f 0a 09  ripts[@]}"; do..
1840: 09 09 09 69 66 20 75 73 65 43 6f 6d 6d 6f 6e 42  ...if useCommonB
1850: 75 69 6c 64 53 79 73 74 65 6d 20 22 24 7b 62 75  uildSystem "${bu
1860: 69 6c 64 5f 73 63 72 69 70 74 7d 22 3b 20 74 68  ild_script}"; th
1870: 65 6e 0a 09 09 09 09 09 28 0a 09 09 09 09 09 09  en......(.......
1880: 2e 20 2e 2e 2f 63 6f 6d 6d 6f 6e 2f 63 6f 6d 6d  . ../common/comm
1890: 6f 6e 2e 73 68 0a 09 09 09 09 09 09 2e 20 22 24  on.sh........ "$
18a0: 7b 62 75 69 6c 64 5f 73 63 72 69 70 74 7d 22 0a  {build_script}".
18b0: 0a 09 09 09 09 09 09 73 65 74 20 2d 78 0a 0a 09  .......set -x...
18c0: 09 09 09 09 09 69 66 20 5b 20 22 24 7b 63 61 6c  .....if [ "${cal
18d0: 6c 5f 70 6b 67 5f 69 6e 69 74 7d 22 20 3d 20 27  l_pkg_init}" = '
18e0: 31 27 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09 09  1' ]; then......
18f0: 09 09 69 6e 69 74 20 7c 7c 20 64 69 65 20 27 69  ..init || die 'i
1900: 6e 69 74 20 66 61 69 6c 65 64 27 0a 09 09 09 09  nit failed'.....
1910: 09 09 66 69 0a 0a 09 09 09 09 09 09 70 72 65 64  ..fi........pred
1920: 6f 77 6e 6c 6f 61 64 20 7c 7c 20 64 69 65 20 27  ownload || die '
1930: 70 72 65 64 6f 77 6e 6c 6f 61 64 20 66 61 69 6c  predownload fail
1940: 65 64 27 0a 09 09 09 09 09 09 64 6f 77 6e 6c 6f  ed'.......downlo
1950: 61 64 20 7c 7c 20 64 69 65 20 27 64 6f 77 6e 6c  ad || die 'downl
1960: 6f 61 64 20 66 61 69 6c 65 64 27 0a 09 09 09 09  oad failed'.....
1970: 09 09 70 6f 73 74 64 6f 77 6e 6c 6f 61 64 20 7c  ..postdownload |
1980: 7c 20 64 69 65 20 27 70 6f 73 74 64 6f 77 6e 6c  | die 'postdownl
1990: 6f 61 64 20 66 61 69 6c 65 64 27 0a 0a 09 09 09  oad failed'.....
19a0: 09 09 09 65 78 74 72 61 63 74 20 7c 7c 20 64 69  ...extract || di
19b0: 65 20 27 65 78 74 72 61 63 74 20 66 61 69 6c 65  e 'extract faile
19c0: 64 27 0a 0a 09 09 09 09 09 09 61 70 70 6c 79 5f  d'........apply_
19d0: 70 61 74 63 68 65 73 20 7c 7c 20 64 69 65 20 27  patches || die '
19e0: 61 70 70 6c 79 20 70 61 74 63 68 65 73 20 66 61  apply patches fa
19f0: 69 6c 65 64 27 0a 0a 09 09 09 09 09 09 63 64 20  iled'........cd 
1a00: 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20  "${workdir}" || 
1a10: 65 78 69 74 20 31 0a 0a 09 09 09 09 09 09 70 72  exit 1........pr
1a20: 65 63 6f 6e 66 69 67 75 72 65 20 7c 7c 20 64 69  econfigure || di
1a30: 65 20 27 70 72 65 63 6f 6e 66 69 67 75 72 65 20  e 'preconfigure 
1a40: 66 61 69 6c 65 64 27 0a 09 09 09 09 09 09 63 6f  failed'.......co
1a50: 6e 66 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27  nfigure || die '
1a60: 63 6f 6e 66 69 67 75 72 65 20 66 61 69 6c 65 64  configure failed
1a70: 27 0a 09 09 09 09 09 09 70 6f 73 74 63 6f 6e 66  '.......postconf
1a80: 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27 70 6f  igure || die 'po
1a90: 73 74 63 6f 6e 66 69 67 75 72 65 20 66 61 69 6c  stconfigure fail
1aa0: 65 64 27 0a 0a 09 09 09 09 09 09 70 72 65 62 75  ed'........prebu
1ab0: 69 6c 64 20 7c 7c 20 64 69 65 20 27 70 72 65 62  ild || die 'preb
1ac0: 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 09 09 09  uild failed'....
1ad0: 09 09 09 62 75 69 6c 64 20 7c 7c 20 64 69 65 20  ...build || die 
1ae0: 27 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 09  'build failed'..
1af0: 09 09 09 09 09 70 6f 73 74 62 75 69 6c 64 20 7c  .....postbuild |
1b00: 7c 20 64 69 65 20 27 70 6f 73 74 62 75 69 6c 64  | die 'postbuild
1b10: 20 66 61 69 6c 65 64 27 0a 0a 09 09 09 09 09 09   failed'........
1b20: 70 72 65 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69  preinstall || di
1b30: 65 20 27 70 72 65 69 6e 73 74 61 6c 6c 20 66 61  e 'preinstall fa
1b40: 69 6c 65 64 27 0a 09 09 09 09 09 09 69 6e 73 74  iled'.......inst
1b50: 61 6c 6c 20 7c 7c 20 64 69 65 20 27 69 6e 73 74  all || die 'inst
1b60: 61 6c 6c 20 66 61 69 6c 65 64 27 0a 09 09 09 09  all failed'.....
1b70: 09 09 70 6f 73 74 69 6e 73 74 61 6c 6c 20 7c 7c  ..postinstall ||
1b80: 20 64 69 65 20 27 70 6f 73 74 69 6e 73 74 61 6c   die 'postinstal
1b90: 6c 20 66 61 69 6c 65 64 27 0a 0a 09 09 09 09 09  l failed'.......
1ba0: 09 63 72 65 61 74 65 72 75 6e 74 69 6d 65 20 7c  .createruntime |
1bb0: 7c 20 64 69 65 20 27 63 72 65 61 74 65 72 75 6e  | die 'createrun
1bc0: 74 69 6d 65 20 66 61 69 6c 65 64 27 0a 0a 09 09  time failed'....
1bd0: 09 09 09 09 73 65 74 20 2b 78 0a 0a 09 09 09 09  ....set +x......
1be0: 09 09 72 6d 20 2d 72 66 20 22 24 7b 77 6f 72 6b  ..rm -rf "${work
1bf0: 64 69 72 7d 22 0a 09 09 09 09 09 29 20 33 3e 26  dir}"......) 3>&
1c00: 31 20 34 3e 26 32 20 3e 3e 20 62 75 69 6c 64 2e  1 4>&2 >> build.
1c10: 6c 6f 67 20 32 3e 26 31 20 7c 7c 20 65 78 69 74  log 2>&1 || exit
1c20: 20 31 0a 09 09 09 09 65 6c 73 65 0a 09 09 09 09   1.....else.....
1c30: 09 22 24 7b 62 75 69 6c 64 5f 73 63 72 69 70 74  ."${build_script
1c40: 7d 22 20 33 3e 26 31 20 34 3e 26 32 20 3e 3e 20  }" 3>&1 4>&2 >> 
1c50: 62 75 69 6c 64 2e 6c 6f 67 20 32 3e 26 31 20 7c  build.log 2>&1 |
1c60: 7c 20 65 78 69 74 20 31 0a 09 09 09 09 66 69 0a  | exit 1.....fi.
1c70: 0a 09 09 09 09 63 61 6c 6c 5f 70 6b 67 5f 69 6e  .....call_pkg_in
1c80: 69 74 3d 27 30 27 0a 09 09 09 64 6f 6e 65 0a 09  it='0'....done..
1c90: 09 29 20 7c 7c 20 66 61 69 6c 65 64 3d 22 31 22  .) || failed="1"
1ca0: 0a 09 66 69 0a 0a 09 69 66 20 5b 20 22 24 7b 66  ..fi...if [ "${f
1cb0: 61 69 6c 65 64 7d 22 20 3d 20 22 31 22 20 5d 3b  ailed}" = "1" ];
1cc0: 20 74 68 65 6e 0a 09 09 65 63 68 6f 20 22 20 66   then...echo " f
1cd0: 61 69 6c 65 64 2e 22 0a 09 09 66 61 69 6c 65 64  ailed."...failed
1ce0: 70 6b 67 73 3d 22 24 7b 66 61 69 6c 65 64 70 6b  pkgs="${failedpk
1cf0: 67 73 7d 20 24 7b 70 6b 67 7d 22 0a 09 65 6c 73  gs} ${pkg}"..els
1d00: 65 0a 09 09 65 63 68 6f 20 22 20 64 6f 6e 65 2e  e...echo " done.
1d10: 22 0a 09 66 69 0a 0a 09 63 61 73 65 20 22 24 7b  "..fi...case "${
1d20: 70 6b 67 7d 22 20 69 6e 0a 09 09 74 63 6c 29 0a  pkg}" in...tcl).
1d30: 09 09 09 54 43 4c 43 4f 4e 46 49 47 44 49 52 3d  ...TCLCONFIGDIR=
1d40: 24 28 66 69 6e 64 20 22 24 28 70 77 64 29 2f 74  $(find "$(pwd)/t
1d50: 63 6c 2f 62 75 69 6c 64 22 20 2d 6e 61 6d 65 20  cl/build" -name 
1d60: 74 63 6c 43 6f 6e 66 69 67 2e 73 68 20 7c 20 68  tclConfig.sh | h
1d70: 65 61 64 20 2d 31 20 7c 20 73 65 64 20 27 73 40  ead -1 | sed 's@
1d80: 2f 5b 5e 2f 5d 2a 24 40 40 27 29 0a 09 09 09 54  /[^/]*$@@')....T
1d90: 43 4c 43 4f 4e 46 49 47 44 49 52 54 41 49 4c 3d  CLCONFIGDIRTAIL=
1da0: 22 24 28 62 61 73 65 6e 61 6d 65 20 22 24 7b 54  "$(basename "${T
1db0: 43 4c 43 4f 4e 46 49 47 44 49 52 7d 22 29 22 0a  CLCONFIGDIR}")".
1dc0: 09 09 09 65 78 70 6f 72 74 20 54 43 4c 43 4f 4e  ...export TCLCON
1dd0: 46 49 47 44 49 52 20 54 43 4c 43 4f 4e 46 49 47  FIGDIR TCLCONFIG
1de0: 44 49 52 54 41 49 4c 0a 0a 09 09 09 23 20 49 66  DIRTAIL.....# If
1df0: 20 54 63 6c 20 77 61 73 20 63 6f 6d 70 69 6c 65   Tcl was compile
1e00: 64 20 77 69 74 68 20 74 68 72 65 61 64 73 20 65  d with threads e
1e10: 6e 61 62 6c 65 64 20 70 61 73 73 20 2d 2d 65 6e  nabled pass --en
1e20: 61 62 6c 65 2d 74 68 72 65 61 64 73 20 74 6f 20  able-threads to 
1e30: 61 6c 6c 20 73 75 62 2d 70 72 6f 6a 65 63 74 73  all sub-projects
1e40: 0a 09 09 09 69 66 20 5b 20 22 24 7b 4b 49 54 43  ....if [ "${KITC
1e50: 52 45 41 54 4f 52 5f 41 44 44 5f 45 4e 41 42 4c  REATOR_ADD_ENABL
1e60: 45 5f 54 48 52 45 41 44 53 3a 2d 31 7d 22 20 21  E_THREADS:-1}" !
1e70: 3d 20 27 30 27 20 5d 3b 20 74 68 65 6e 0a 09 09  = '0' ]; then...
1e80: 09 09 69 66 20 5b 20 22 24 28 20 2e 20 22 24 7b  ..if [ "$( . "${
1e90: 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d 2f 74 63  TCLCONFIGDIR}/tc
1ea0: 6c 43 6f 6e 66 69 67 2e 73 68 22 20 26 26 20 65  lConfig.sh" && e
1eb0: 63 68 6f 20 22 24 7b 54 43 4c 5f 54 48 52 45 41  cho "${TCL_THREA
1ec0: 44 53 3a 2d 30 7d 22 20 29 22 20 3d 20 27 31 27  DS:-0}" )" = '1'
1ed0: 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09 09 43 4f   ]; then......CO
1ee0: 4e 46 49 47 55 52 45 45 58 54 52 41 3d 22 24 7b  NFIGUREEXTRA="${
1ef0: 43 4f 4e 46 49 47 55 52 45 45 58 54 52 41 7d 20  CONFIGUREEXTRA} 
1f00: 2d 2d 65 6e 61 62 6c 65 2d 74 68 72 65 61 64 73  --enable-threads
1f10: 22 0a 09 09 09 09 66 69 0a 09 09 09 66 69 0a 09  ".....fi....fi..
1f20: 09 09 3b 3b 0a 09 65 73 61 63 0a 0a 09 69 66 20  ..;;..esac...if 
1f30: 5b 20 22 24 7b 66 61 69 6c 65 64 7d 22 20 3d 20  [ "${failed}" = 
1f40: 22 31 22 20 5d 3b 20 74 68 65 6e 0a 09 09 62 75  "1" ]; then...bu
1f50: 69 6c 64 66 61 69 6c 65 64 3d 22 31 22 0a 09 65  ildfailed="1"..e
1f60: 6c 73 65 0a 09 09 74 6f 75 63 68 20 22 24 7b 70  lse...touch "${p
1f70: 6b 67 7d 2f 2e 73 75 63 63 65 73 73 22 0a 09 66  kg}/.success"..f
1f80: 69 0a 64 6f 6e 65 0a 0a 69 66 20 5b 20 2d 6e 20  i.done..if [ -n 
1f90: 22 24 7b 66 61 69 6c 65 64 70 6b 67 73 7d 22 20  "${failedpkgs}" 
1fa0: 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 46  ]; then..echo "F
1fb0: 61 69 6c 65 64 20 74 6f 20 62 75 69 6c 64 3a 24  ailed to build:$
1fc0: 7b 66 61 69 6c 65 64 70 6b 67 73 7d 22 0a 66 69  {failedpkgs}".fi
1fd0: 0a 0a 69 66 20 5b 20 22 24 7b 62 75 69 6c 64 66  ..if [ "${buildf
1fe0: 61 69 6c 65 64 7d 22 20 21 3d 20 22 30 22 20 5d  ailed}" != "0" ]
1ff0: 3b 20 74 68 65 6e 0a 09 65 63 68 6f 20 27 57 41  ; then..echo 'WA
2000: 52 4e 49 4e 47 3a 20 42 75 69 6c 64 20 69 73 20  RNING: Build is 
2010: 6c 69 6b 65 6c 79 20 69 6e 63 6f 6d 70 6c 65 74  likely incomplet
2020: 65 20 6f 72 20 66 61 69 6c 65 64 2e 27 20 3e 26  e or failed.' >&
2030: 32 0a 66 69 0a 0a 63 70 20 27 6b 69 74 73 68 2f  2.fi..cp 'kitsh/
2040: 62 75 69 6c 64 27 2f 6b 69 74 73 68 2d 2a 2f 6c  build'/kitsh-*/l
2050: 69 62 74 63 6c 6b 69 74 2a 20 2e 20 3e 2f 64 65  ibtclkit* . >/de
2060: 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75  v/null 2>/dev/nu
2070: 6c 6c 0a 63 70 20 27 6b 69 74 73 68 2f 62 75 69  ll.cp 'kitsh/bui
2080: 6c 64 27 2f 6b 69 74 73 68 2d 2a 2f 6b 69 74 20  ld'/kitsh-*/kit 
2090: 22 74 63 6c 6b 69 74 2d 24 7b 54 43 4c 56 45 52  "tclkit-${TCLVER
20a0: 53 7d 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32  S}" >/dev/null 2
20b0: 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 69 66 20 5b 20  >/dev/null.if [ 
20c0: 21 20 2d 66 20 22 74 63 6c 6b 69 74 2d 24 7b 54  ! -f "tclkit-${T
20d0: 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68 65 6e  CLVERS}" ]; then
20e0: 0a 09 63 70 20 27 6b 69 74 73 68 2f 62 75 69 6c  ..cp 'kitsh/buil
20f0: 64 27 2f 6b 69 74 73 68 2d 2a 2f 6b 69 74 2e 65  d'/kitsh-*/kit.e
2100: 78 65 20 22 74 63 6c 6b 69 74 2d 24 7b 54 43 4c  xe "tclkit-${TCL
2110: 56 45 52 53 7d 22 20 3e 2f 64 65 76 2f 6e 75 6c  VERS}" >/dev/nul
2120: 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 66 69  l 2>/dev/null.fi
2130: 0a 0a 66 6f 72 20 70 6f 73 74 73 63 72 69 70 74  ..for postscript
2140: 20 69 6e 20 63 6f 6d 6d 6f 6e 2f 70 6f 73 74 2f   in common/post/
2150: 2a 3b 20 64 6f 0a 09 69 66 20 5b 20 21 20 2d 66  *; do..if [ ! -f
2160: 20 22 24 7b 70 6f 73 74 73 63 72 69 70 74 7d 22   "${postscript}"
2170: 20 5d 3b 20 74 68 65 6e 0a 09 09 63 6f 6e 74 69   ]; then...conti
2180: 6e 75 65 0a 09 66 69 0a 0a 09 22 24 7b 70 6f 73  nue..fi..."${pos
2190: 74 73 63 72 69 70 74 7d 22 0a 64 6f 6e 65 0a 0a  tscript}".done..
21a0: 65 78 69 74 20 22 24 7b 62 75 69 6c 64 66 61 69  exit "${buildfai
21b0: 6c 65 64 7d 22 0a                                led}".